' DISKREAD: A program to read absolute hard disk sectors and
'           display the data.  It will NOT write to the drive.
'
' Copyright 1986, 1987  Michael L. Brown
'                       Nicolet Instrument Corp
'                       5225-2 Verona Rd
'                       PO Box 4288
'                       Madison, WI  53711-0288
'
' User is hereby granted permission to use said program.  User is not
' allowed to sell said program.  User may include said program with other
' programs, but may not charge extra for its inclusion.
'
' Source of said program may also be distributed.  Please send any problems
' or code enhancements to the above address or electronically to:
'                 The NICBUL BBS system  (608) 273-5037  6pm to 8am M-F
'                                                        All day S-S  (CT)
'              or via UUCP to ..!ihnp4!nicmad!brown
'                             ..!seismo!uwvax!nicmad!brown
'
' Version 1.2     November 4, 1986
'         1.3     March 16, 1987
'         1.4      6/24/87   Added main menu option 5: Copy complete disk
'                            from one drive to another.
'         1.5      7/14/87   Added copying multiple (sequential) sectors.
'
      VER$="Version 1.5"
      DISPLAY% = 1
      DRIVE%=128
      CYL%=0
      HEAD%=0
      SECTOR%=1
      ACYL% = 0
      BCYL% = 0
      AHEAD% = 0
      BHEAD% = 0
      ASECTOR% = 1
      BSECTOR% = 1
      GOSUB READPARAM
      IF AH% = 0 THEN
         GOSUB COMPAREDRV
	 GOTO 10
      END IF
      LOCATE 3,1,0
      PRINT "Error while trying to read drive 0 parameters."
      PRINT "The hard disk controller board returned an error of:";AH%
      LOCATE 10,1,0
      END
'
' Clear the screen and set up the main menu
'
10    CLS
      HPOS% = 20
      GOSUB BOX
20    LOCATE 5,34,0
      PRINT CHR$(181);
      COLOR 0,7
      PRINT " MAIN MENU ";
      COLOR 7,0
      PRINT CHR$(198);
30    LOCATE 6,22,0
      PRINT "DISKREAD"
      LOCATE 6,58-LEN(VER$),0
      PRINT VER$
40    LOCATE 8,22,0
      PRINT "F1 - Select Drive Parameters"
      LOCATE 9,22,0
      PRINT "F2 - Display Disk Partition Table"
      LOCATE 10,22,0
      PRINT "F3 - Read Drive Data"
      LOCATE 11,22,0
      PRINT "F4 - Copy Disk Sector"
      IF DRIVESEQUAL% THEN
         LOCATE 12,22,0
         PRINT "F5 - Copy Entire Disk"
      END IF
      LOCATE 14,22,0
      PRINT "ESC- Return To DOS"
      GOSUB INFO
50    IF DRIVESEQUAL% THEN
         MAXKEY% = 5
         MAXFUNC% = 5
      ELSE
         MAXKEY% = 4
         MAXFUNC% = 4
      END IF
      GOSUB READKEY
      IF KEYVAL% = 27 THEN CLS :_
         END
      ON KEYVAL% GOTO 10000, _   'Select Drive
                      20000, _   'Display Partition Table
                      30000, _   'Read Drive Data
                      40000, _   'Copy Disk Sector
                      50000      'Copy Entire Disk
      GOTO 50
'
'Select the parameters
'
10000 CLS
      HPOS% = 20
      GOSUB BOX
      LOCATE 5,32,0
      PRINT CHR$(181);
      COLOR 0,7
      PRINT " SELECT DRIVE ";
      COLOR 7,0
      PRINT CHR$(198)
10010 LOCATE 7,22,0
      PRINT "F1  - Select First Hard Disk"
      LOCATE 8,22,0
      PRINT "F2  - Select Second Hard Disk"
      LOCATE 9,22,0
      PRINT "F3  - Select Disk Cylinder"
      LOCATE 10,22,0
      PRINT "F4  - Select Disk Head"
      LOCATE 11,22,0
      PRINT "F5  - Select Disk Sector"
      LOCATE 14,22,0
      PRINT "ESC - Return To Main Menu"
10020 MAXKEY% = 0
      MAXFUNC% = 5
      IF DRIVE% = 128 THEN _
         ACYL% = CYL% :_
         AHEAD% = HEAD% :_
         ASECTOR% = SECTOR%
      IF DRIVE% = 129 THEN _
         BCYL% = CYL% :_
         BHEAD% = HEAD% :_
         BSECTOR% = SECTOR%
      LOCATE 17,20,0
      IF DRIVE% = 128 AND MAXDRV% = 2 THEN COLOR 15,0
      PRINT "Drive: 0";"  Cylinder:";
      PRINT USING "#####";ACYL%;
      PRINT "  Head:";AHEAD%;" Sector:";
      PRINT USING "###";ASECTOR%;
      COLOR 7,0
      IF MAXDRV% < 2 THEN 10030
      IF DRIVE% = 129 THEN COLOR 15,0
      LOCATE 18,20,0
      PRINT "Drive: 1";"  Cylinder:";
      PRINT USING "#####";BCYL%;
      PRINT "  Head:";BHEAD%;" Sector:";
      PRINT USING "###";BSECTOR%;
      COLOR 7,0
10030 GOSUB INFO
      GOSUB READKEY
      IF KEYVAL% = 27 THEN 10
      IF KEYVAL% < 3 AND MAXDRV% = 2 THEN DRIVE% = KEYVAL%-1+128 :_
         GOSUB READPARAM :_
         IF DRIVE% = 128 THEN _
            CYL% = ACYL% :_
            HEAD% = AHEAD% :_
            SECTOR% = ASECTOR%
         IF DRIVE% = 129 THEN _
            CYL% = BCYL% :_
            HEAD% = BHEAD% :_
            SECTOR% = BSECTOR%
      IF KEYVAL% = 3 THEN LOCATE 22,1,1 :_
         INPUT;"Enter Cylinder number: ",TMP%
      IF KEYVAL% = 4 THEN LOCATE 22,1,1 :_
         INPUT;"Enter Head number: ",TMP%
      IF KEYVAL% = 5 THEN LOCATE 22,1,1 :_
         INPUT;"Enter Sector number: ",TMP%
      IF KEYVAL% = 3 AND TMP% <= MAXCYL% THEN CYL% = TMP%
      IF KEYVAL% = 4 AND TMP% <= MAXHEAD% THEN HEAD% = TMP%
      IF KEYVAL% = 5 AND TMP% <= MAXSEC% AND TMP% > 0 THEN SECTOR% = TMP%
      LOCATE 22,1,0
      PRINT SPACE$(40)
      GOTO 10020
'
' Display the drive's partition table
'
20000 CLS
      VPOS% = 1
      HPOS% = 1
      WASDRIVE% = DRIVE%
      DRIVE% = 128
20010 GOSUB FBOX
      IF DRIVE% = 128 THEN LOCATE 1,29 :_
         PRINT CHR$(181); :_
         COLOR 0,7 :_
         PRINT " PARTITION INFORMATION "; :_
         COLOR 7,0 :_
         PRINT CHR$(198);
      LOCATE VPOS%+1,HPOS%+36
      PRINT "DRIVE";DRIVE%-128
      LOCATE VPOS%+2,HPOS%
      PRINT CHR$(199);
      FOR L = 1 TO 78
          PRINT CHR$(196);
      NEXT
      PRINT CHR$(182);
      GOSUB READPARAM
      IF AH% = 0 THEN 20020
      LOCATE VPOS%+9,HPOS%+22
      PRINT "Error ";HEX$(AH%);" while reading drive parameters";
      GOTO 20100
20020 CYL% = 0
      HEAD% = 0
      SECTOR% = 1
      AH% = 2
      GOSUB CALLINT
      DEF SEG = ES%
      IF PEEK(BX%+510) = &H55 AND PEEK(BX%+511) = &HAA THEN 20030
      LOCATE VPOS%+9,HPOS%+27
      PRINT "This disk is not partitioned"
      GOTO 20100
20030 LOCATE VPOS%+3,HPOS%+2
      PRINT "# SYS TYPE START   END   SIZE      BYTES";
      PRINT "  REL. SEC. OFFSET    NUMBER SECTORS";
      PART% = BX%+&H1BE
      FOR VPOS% = VPOS%+5 TO VPOS%+8
          BOOT% = PEEK(PART%)
          BEGHEAD% = PEEK(PART%+1)
          BEGSEC% = PEEK(PART%+2)
          BEGCYL% = PEEK(PART%+3)+((BEGSEC% AND &HC0)*4)
          BEGSEC% = BEGSEC% AND &H3F
          SYSIND% = PEEK(PART%+4)
          ENDHEAD% = PEEK(PART%+5)
          ENDSEC% = PEEK(PART%+6)
          ENDCYL% = PEEK(PART%+7)+((ENDSEC% AND &HC0)*4)
          ENDSEC% = ENDSEC% AND &H3F
          RELSEC# = PEEK(PART%+8)+(PEEK(PART%+9)*256#)+(PEEK(PART%+10)*65536#)
          RELSEC# = RELSEC# +(PEEK(PART%+11)*16777216#)
          NUMSEC# = PEEK(PART%+12)+(PEEK(PART%+13)*256#)+(PEEK(PART%+14)*65536#)
          NUMSEC# = NUMSEC# +(PEEK(PART%+15)*16777216#)
          LOCATE VPOS%,HPOS%+1
          IF DRIVE% = 128 THEN PRINT VPOS%-5;
          IF DRIVE% = 129 THEN PRINT VPOS%-17;
          IF NUMSEC# = 0 THEN 20040
          IF SYSIND% = &H01 OR SYSIND% = &H04 THEN PRINT "DOS "; _
             ELSE PRINT "    ";
          IF BOOT% = &H80 THEN PRINT "  A "; _
             ELSE PRINT "    ";
          PRINT USING "######";BEGCYL%;ENDCYL%;
          PRINT USING "#######";ENDCYL%-BEGCYL%+1;
          PRINT USING "###,###,###";NUMSEC# * 512;
          PRINT USING "######,###,###,###";RELSEC#;NUMSEC#;
20040 PART% = PART%+16
      NEXT
      IF MAXDRV% < 2 THEN 20100
      IF DRIVE% = 129 THEN 20100
      DRIVE% = 129
      VPOS% = 13
      GOTO 20010
20100 IF INKEY$ = "" THEN 20100
      DRIVE% = WASDRIVE%
      GOTO 10
'
' Read and display requested drive sector
'
30000 CLS
      LOCATE 2,1,0
      PRINT CHR$(201);
      FOR L = 1 TO 78
          PRINT CHR$(205);
      NEXT
      PRINT CHR$(187);
      FOR L = 3 TO 24
          LOCATE L,80,0
          PRINT CHR$(186);
      NEXT
      LOCATE 25,80,0
      PRINT CHR$(188);
      FOR L = 79 TO 2 STEP -1
          LOCATE 25,L,0
          PRINT CHR$(205);
      NEXT
      LOCATE 25,1,0
      PRINT CHR$(200);
      FOR L = 24 TO 3 STEP -1
          LOCATE L,1,0
          PRINT CHR$(186);
      NEXT
      LOCATE 2,55,0
      PRINT CHR$(209);
      FOR L = 3 TO 24
          LOCATE L,55,0
          PRINT CHR$(179);
      NEXT
      LOCATE 25,55,0
      PRINT CHR$(207);
      LOCATE 24,29,0
      PRINT "Press ";
      COLOR 15,0
      PRINT "Enter ";
      COLOR 7,0
      PRINT "for help.";
      LOCATE 1,75
      IF DISPLAY% = 1 THEN PRINT "D"; ELSE PRINT " ";
      IF DOAUTO% = 1 THEN PRINT "A"; ELSE PRINT " ";
      IF REWRITE% = 1 THEN PRINT "W"; ELSE PRINT " ";
30010 AH% = 2
      GOSUB CALLINT
      LOCATE 1,1,0
      PRINT "Drive:";DRIVE%-128;
      PRINT TAB(12);"Cylinder:";CYL%;
      PRINT TAB(27);"Head:";HEAD%;
      PRINT TAB(37);"Sector:";SECTOR%;
      PRINT TAB(55);"Return code: ";HEX$(AH%);"h ";
      IF AH% <> 0 THEN LOCATE 24,67 :_
         PRINT CYL%;TAB(73);HEAD%;SECTOR%;
      'If the re-write flag is on and the previous read had an error 11h,
      'then write it back out.  Maybe that will fix the error.
      IF REWRITE% = 0 THEN 30020
      IF AH% <> &H11 THEN 30020
      AH% = 3
      GOSUB CALLINT
      'Put up hex data
30020 IF DISPLAY% = 0 THEN 30040
      LOCATE 3,2,0
      DEF SEG = ES%
      COL% = 0
      COUNT% = 0
      FOR L% = BX% TO BX%+511
          NUM% = PEEK(L%)
          A$ = HEX$(NUM%)
          IF LEN(A$) = 1 THEN PRINT "0";
          PRINT A$;
          COL% = COL%+1
          COUNT% = COUNT%+1
          IF COL% = 24 THEN PRINT: _
             LOCATE ,2,0: _
             COL% = 0: _
             COUNT% = 0
          IF COUNT% = 4 THEN PRINT " ";: _
             COUNT% = 0
      NEXT
      'Put up ASCII data
30030 LOCATE 3,56,0
      COL% = 0
      FOR L% = BX% TO BX%+511
          NUM% = PEEK(L%)
          IF NUM% < 32 THEN NUM% = NUM% OR &H40 :_
             COLOR 0,7
          A$ = CHR$(NUM%)
          PRINT A$;
          COL% = COL%+1
          IF COL% = 24 THEN PRINT :_
             COL% = 0 :_
             LOCATE ,56,0
          COLOR 7,0
      NEXT
      DEF SEG
30040 IN$ = INKEY$
      IF IN$ = "" AND DOAUTO% = 0 THEN 30040
      IF IN$ = "" AND DOAUTO% = 1 THEN 30050
      IF IN$ = CHR$(13) THEN _
         GOSUB HELPMENU :_
         GOTO 30000
      IF IN$ = CHR$(27) THEN 10
      IF LEFT$(IN$,1) <> CHR$(0) THEN 30040
      IN$ = RIGHT$(IN$,1)
      IF ASC(IN$) < 59 OR ASC(IN$) > 113 THEN 30040
      IF ASC(IN$) = 59 THEN CYL% = CYL%-1              'F1
      IF ASC(IN$) = 60 THEN CYL% = CYL%+1              'F2
      IF ASC(IN$) = 61 THEN HEAD% = HEAD%-1            'F3
      IF ASC(IN$) = 62 THEN HEAD% = HEAD%+1            'F4
      IF ASC(IN$) = 63 THEN SECTOR% = SECTOR%-1        'F5
      IF ASC(IN$) = 64 THEN SECTOR% = SECTOR%+1        'F6
      IF ASC(IN$) = 65 THEN REWRITE% = 0               'F7
      IF ASC(IN$) = 66 THEN REWRITE% = 1               'F8
      IF ASC(IN$) = 67 THEN DOAUTO% = 0                'F9
      IF ASC(IN$) = 68 THEN DOAUTO% = 1                'F10
      IF ASC(IN$) = 104 THEN DISPLAY% = 0              'Alt F1
      IF ASC(IN$) = 105 THEN DISPLAY% = 1              'Alt F2
      LOCATE 1,75
      IF DISPLAY% = 1 THEN PRINT "D"; ELSE PRINT " ";
      IF DOAUTO% = 1 THEN PRINT "A"; ELSE PRINT " ";
      IF REWRITE% = 1 THEN PRINT "W"; ELSE PRINT " ";
      IF ASC(IN$) = 105 THEN 30010
      IF ASC(IN$) > 64 THEN 30040
30050 IF DOAUTO% = 1 THEN SECTOR% = SECTOR%+1
      IF SECTOR% < 1 THEN SECTOR% = MAXSEC% :_
         HEAD% = HEAD%-1
      IF SECTOR% > MAXSEC% THEN SECTOR% = 1 :_
         HEAD% = HEAD%+1
      IF HEAD% < 0 THEN HEAD% = MAXHEAD% :_
         SECTOR% = 17 :_
         CYL% = CYL%-1
      IF HEAD% > MAXHEAD% THEN HEAD% = 0 :_
         SECTOR% = 1 :_
         CYL% = CYL%+1
      IF CYL% < 0 THEN CYL% = MAXCYL% :_
         HEAD% = MAXHEAD% :_
         SECTOR% = MAXSEC%
      IF CYL% > MAXCYL% THEN CYL% = 0 :_
         HEAD% = 0 :_
         SECTOR% = 1
      GOTO 30010
'
' Copy a disk sector to another sector, on same or different drive
'
40000 WASDRIVE% = DRIVE%
      WASCYL% = CYL%
      WASHEAD% = HEAD%
      WASSECTOR% = SECTOR%
40010 FDRIVE% = 0
      IF MAXDRV% < 2 THEN 40020
      LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter drive to copy from (0 or 1): ",FDRIVE%
      IF FDRIVE% < 0 OR FDRIVE% > 1 THEN 40010
40020 FDRIVE% = FDRIVE%+128
      IF FDRIVE% = 128 THEN
	    FMAXCYL% = AMAXCYL%
	    FMAXHEAD% = AMAXHEAD%
	    FMAXSEC% = AMAXSEC%
	 ELSE
	    FMAXCYL% = BMAXCYL%
	    FMAXHEAD% = BMAXHEAD%
	    FMAXSEC% = BMAXSEC%
      END IF
40030 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter cylinder to copy from: ",FCYL%
      IF FCYL% < 0 OR FCYL% > FMAXCYL% THEN 40030
40040 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter head to copy from: ",FHEAD%
      IF FHEAD% < 0 OR FHEAD% > FMAXHEAD% THEN 40040
40050 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter sector to copy from: ",FSECTOR%
      IF FSECTOR% < 1 OR FSECTOR% > FMAXSEC% THEN 40050
40060 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter number of sectors to copy: ",COPYCOUNT%
      IF COPYCOUNT% < 1 THEN COPYCOUNT% = 1
      LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
40100 TDRIVE% = 0
      IF MAXDRV% < 2 THEN 40105
      INPUT;"Enter drive to copy to: ",TDRIVE%
      IF TDRIVE% < 0 OR TDRIVE% > 1 THEN 40100
40105 TDRIVE% = TDRIVE%+128
      IF TDRIVE% = 128 THEN
	    TMAXCYL% = AMAXCYL%
	    TMAXHEAD% = AMAXHEAD%
	    TMAXSEC% = AMAXSEC%
	 ELSE
	    TMAXCYL% = BMAXCYL%
	    TMAXHEAD% = BMAXHEAD%
	    TMAXSEC% = BMAXSEC%
      END IF
40110 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter cylinder to copy to: ",TCYL%
      IF TCYL% < 0 OR TCYL% > TMAXCYL% THEN 40110
40120 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter head to copy to: ",THEAD%
      IF THEAD% < 0 OR THEAD% > TMAXHEAD% THEN 40120
40130 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter sector to copy to: ",TSECTOR%
      IF TSECTOR% < 1 OR TSECTOR% > TMAXSEC% THEN 40130
      LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      '
      'At this point, read all the sectors to see if any are bad,
      '  if so, abort this job.
      '
40200 DRIVE% = FDRIVE%
      CYL% = FCYL%
      HEAD% = FHEAD%
      SECTOR% = FSECTOR%
      BADREAD% = 0
      FOR L% = 1 TO COPYCOUNT%
	  AH% = 2
	  GOSUB CALLINT
	  IF AH% <> 0 AND AH% <> &H11 THEN
	     BADREAD% = -1
	     EXIT FOR
	  END IF
	  SECTOR% = SECTOR% + 1
	  IF SECTOR% > FMAXSEC% THEN
	     SECTOR% = 1
	     HEAD% = HEAD% + 1
	  END IF
	  IF HEAD% > FMAXHEAD% THEN
	     HEAD% = 0
	     CYL% = CYL% + 1
	  END IF
	  IF CYL% > FMAXCYL% THEN
	     CYL% = 0
	  END IF
      NEXT
      IF BADREAD% THEN
	 BEEP
	 PRINT "The initial read check was unsuccessful.  ";
	 PRINT "Error code: ";HEX$(AH%);"h.";
	 PRINT "Cylinder: ";CYL%;"  Head: ";HEAD%;"  Sector: ";SECTOR%
	 PRINT "  Press any key to continue."
40210    IF INKEY$ = "" THEN 40210
	 GOTO 40900
      END IF
      '
      'At this point, copy the sectors.
      '
40300 BADWRITE% = 0
      BADREAD% = 0
      FOR L% = 1 TO COPYCOUNT%
	  DRIVE% = FDRIVE%
	  CYL% = FCYL%
	  HEAD% = FHEAD%
	  SECTOR% = FSECTOR%
	  AH% = 2
	  GOSUB CALLINT
	  IF AH% <> 0 AND AH% <> &H11 THEN
	     BADREAD% = -1
	     EXIT FOR
	  END IF
	  FSECTOR% = FSECTOR% + 1
	  IF FSECTOR% > FMAXSEC% THEN
	     FSECTOR% = 1
	     FHEAD% = FHEAD% + 1
	  END IF
	  IF FHEAD% > FMAXHEAD% THEN
	     FHEAD% = 0
	     FCYL% = FCYL% + 1
	  END IF
	  IF FCYL% > FMAXCYL% THEN
	     FCYL% = 0
	  END IF
	  DRIVE% = TDRIVE%
	  CYL% = TCYL%
	  HEAD% = THEAD%
	  SECTOR% = TSECTOR%
	  AH% = 3
	  GOSUB CALLINT
	  IF AH% <> 0 AND AH% <> &H11 THEN
	     BADWRITE% = -1
	     EXIT FOR
	  END IF
	  TSECTOR% = TSECTOR% + 1
	  IF TSECTOR% > FMAXSEC% THEN
	     TSECTOR% = 1
	     THEAD% = THEAD% + 1
	  END IF
	  IF THEAD% > FMAXHEAD% THEN
	     THEAD% = 0
	     TCYL% = TCYL% + 1
	  END IF
	  IF TCYL% > FMAXCYL% THEN
	     TCYL% = 0
	  END IF
      NEXT
      IF BADREAD% THEN
	 BEEP
	 PRINT "The read was unsuccessful.  ";
	 PRINT "Error code: ";HEX$(AH%);"h.";
	 PRINT "Cylinder: ";CYL%;"  Head: ";HEAD%;"  Sector: ";SECTOR%
	 PRINT "  Press any key to continue."
40310    IF INKEY$ = "" THEN 40310
	 GOTO 40900
      END IF
      IF BADWRITE% THEN
	 BEEP
	 PRINT "The write was unsuccessful.  ";
	 PRINT "Error code: ";HEX$(AH%);"h.";
	 PRINT "Cylinder: ";CYL%;"  Head: ";HEAD%;"  Sector: ";SECTOR%
	 PRINT "  Press any key to continue."
40320    IF INKEY$ = "" THEN 40320
	 GOTO 40900
      END IF
40900 DRIVE% = WASDRIVE%
      CYL% = WASCYL%
      HEAD% = WASHEAD%
      SECTOR% = WASSECTOR%
      LOCATE 22,10
      PRINT SPC(70)
      GOTO 50
'
' Copy entire drive from one drive to another
'
50000 WASDRIVE% = DRIVE%
      LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Enter drive to copy from (0 or 1): ",FDRIVE%
      IF FDRIVE% < 0 OR FDRIVE% > 1 THEN 50000
      FDRIVE% = FDRIVE% + 128
      IF FDRIVE% = 128 THEN
	 TDRIVE% = 129
      ELSE
	 TDRIVE% = 128
      END IF
50010 LOCATE 22,10
      PRINT SPC(60)
      LOCATE 22,10
      INPUT;"Are you sure you want to do this? [n]: ",IN$
      IF IN$ = "" OR IN$ = "N" OR IN$ = "n" THEN
         LOCATE 22,10
         PRINT SPC(60)
	 GOTO 50060
      END IF
      IF IN$ <> "Y" AND IN$ <> "y" THEN 50010
50020 IF WASDRIVE% = 128 THEN
         ACYL% = CYL%
         AHEAD% = HEAD%
         ASECTOR% = SECTOR%
      END IF
      IF WASDRIVE% = 129 THEN
         BCYL% = CYL%
         BHEAD% = HEAD%
         BSECTOR% = SECTOR%
      END IF
      LOCATE 22,10
      PRINT SPC(70)
      LOCATE 22,10
      PRINT "CYLINDER  HEAD  SECTOR"
      DRIVE% = FDRIVE%
      GOSUB READPARAM
50030 FOR CYL% = 0 TO MAXCYL%
	  FOR HEAD% = 0 TO MAXHEAD%
	      FOR SECTOR% = 1 TO MAXSEC%
                  ERRORCOUNT% = 0
		  DRIVE% = FDRIVE%
50040             AH% = 2
                  GOSUB CALLINT
		  IF AH% <> 0 THEN
                     LOCATE 22,40,0
                     PRINT "READ ERROR: CYL:";
                     PRINT USING "#####";CYL%;
                     PRINT "  HEAD:";
                     PRINT USING "##";HEAD%;
                     PRINT "  SECTOR:";
                     PRINT USING "###";SECTOR%
                     ERRORCOUNT% = ERRORCOUNT% + 1
                     AH% = &H11    'Recalibrate
                     GOSUB CALLINT
                  END IF
                  IF ERRORCOUNT% > 0 AND ERRORCOUNT% < 4 THEN 50040
50050             DRIVE% = TDRIVE%
                  AH% = 3
                  GOSUB CALLINT
                  IF AH% <> 0 THEN
                     LOCATE 23,39,0
                     PRINT "WRITE ERROR: CYL:";
                     PRINT USING "#####";CYL%;
                     PRINT "  HEAD:";
                     PRINT USING "##";HEAD%;
                     PRINT "  SECTOR:";
                     PRINT USING "###";SECTOR%
                  END IF
                  LOCATE 23,12,0
                  PRINT USING "####";CYL%;
                  LOCATE 23,22,0
                  PRINT USING "#";HEAD%;
                  LOCATE 23,28,0
                  PRINT USING "##";SECTOR%
              NEXT SECTOR%
          NEXT HEAD%
      NEXT CYL%
50060 DRIVE% = WASDRIVE%
      IF DRIVE% = 128 THEN
         CYL% = ACYL%
         HEAD% = AHEAD%
         SECTOR% = ASECTOR%
      END IF
      IF DRIVE% = 129 THEN
         CYL% = BCYL%
         HEAD% = BHEAD%
         SECTOR% = BSECTOR%
      END IF
      GOTO 50
'
' Put up the menu box
'
BOX:
      LOCATE 5,HPOS%,0
      PRINT CHR$(201);
      FOR L = 1 TO 38
          PRINT CHR$(205);
      NEXT
      PRINT CHR$(187);
      FOR L = 6 TO 14
         LOCATE L,HPOS%,0
         PRINT CHR$(186);SPC(38);CHR$(186);
      NEXT
      LOCATE 15,HPOS%,0
      PRINT CHR$(200);
      FOR L = 1 TO 38
          PRINT CHR$(205);
      NEXT
      PRINT CHR$(188)
      RETURN
'
' Call the interrupt 13h assembly program
'
CALLINT:
      AL%=1
      DL%=DRIVE%
      DH%=HEAD%
      CL%=SECTOR%
      CYLTOP%=CYL% AND &H7F00
      CYLTOP%=CYLTOP%/4
      CH%=CYL% AND &HFF
      CL%=CYLTOP% OR CL%
      CALL INT13(ES%,BX%,AL%,AH%,CL%,CH%,DL%,DH%)
      RETURN
'
' Compare the two drives to see if they are the same
'
COMPAREDRV:
      DRIVESEQUAL% = 0
      IF MAXDRV% < 2 THEN RETURN
      AMAXCYL% = MAXCYL%
      AMAXHEAD% = MAXHEAD%
      AMAXSEC% = MAXSEC%
      DRIVE% = 129
      GOSUB READPARAM
      BMAXCYL% = MAXCYL%
      BMAXHEAD% = MAXHEAD%
      BMAXSEC% = MAXSEC%
      IF AMAXCYL% = BMAXCYL% AND _
         AMAXHEAD% = BMAXHEAD% AND _
         AMAXSEC% = BMAXSEC% THEN
            DRIVESEQUAL% = -1
      END IF
      DRIVE% = 128
      GOSUB READPARAM
      RETURN
'
' Put up the FDISK box
'
FBOX:
      LOCATE VPOS%,HPOS%,0
      PRINT CHR$(201);
      FOR L = 1 TO 78
          PRINT CHR$(205);
      NEXT
      PRINT CHR$(187);
      FOR L = VPOS%+1 TO VPOS%+8
         LOCATE L,HPOS%,0
         PRINT CHR$(186);SPC(78);CHR$(186);
      NEXT
      LOCATE VPOS%+9,HPOS%,0
      PRINT CHR$(200);
      FOR L = 1 TO 78
          PRINT CHR$(205);
      NEXT
      PRINT CHR$(188)
      RETURN
'
'Help MENU for the read data screen
'
HELPMENU:
      CLS
      PRINT " The data displayed in the right column is in ASCII format."
      PRINT " If the character is in reverse video,";
      PRINT " then it is a control character."
      PRINT
      PRINT " The function keys perform the following functions:"
      PRINT
      PRINT "      F1  Cylinder -               F2  Cylinder +"
      PRINT "      F3  Head -                   F4  Head +"
      PRINT "      F5  Sector -                 F6  Sector +"
      PRINT "      F7  Auto-rewrite off         F8  Auto-rewrite on"
      PRINT "      F9  Auto-increment off       F10 Auto-increment on"
      PRINT "     AF1  Update display off      AF2  Update display on"
      PRINT
      PRINT
      PRINT " Press ESC in the data display screen to return to the main menu."
      PRINT
      PRINT
      PRINT "          Press any key to return to the data display screen."
HELPMENU1:
      IF INKEY$ = "" THEN GOTO HELPMENU1
      RETURN
'
' Display drive information
'
INFO: WASDRIVE% = DRIVE%
      DRIVE% = 128
      LOCATE 20,10,0
      GOSUB INFO2
      IF MAXDRV% < 2 THEN GOTO INFO1
      DRIVE% = 129
      LOCATE 21,10,0
      GOSUB INFO2
INFO1:
      DRIVE% = WASDRIVE%
      RETURN
INFO2:
      GOSUB READPARAM
      PRINT "Drive:";DRIVE%-128;" Cylinders:";
      PRINT USING "#####";MAXCYL%+1;
      PRINT "  Heads:";MAXHEAD%+1;" Sectors:";
      PRINT USING "###";MAXSEC%;
      BYTES# = MAXSEC%*(MAXHEAD%+1)
      BYTES# = BYTES#*(MAXCYL%+1)
      BYTES# = BYTES#*512
      PRINT USING "#####,###,###";BYTES#;
      PRINT " bytes."
      RETURN
'
' Read the keyboard for operator input
'
READKEY:
      IN$=INKEY$
      IF IN$="" THEN GOTO READKEY
      IF IN$ = CHR$(27) THEN _
         KEYVAL% = 27 :_
         RETURN
      IF VAL(IN$) > 0 AND VAL(IN$) < MAXKEY%+1 THEN _
         KEYVAL% = VAL(IN$) :_
         RETURN
      IF LEFT$(IN$,1) <> CHR$(0) THEN GOTO READKEY
      IF ASC(RIGHT$(IN$,1)) < 59 OR ASC(RIGHT$(IN$,1)) > MAXFUNC%+58 THEN _
         GOTO READKEY
      KEYVAL% = ASC(RIGHT$(IN$,1)) - 58
      RETURN
'
' Read the hard drive parameters
'
READPARAM:
      AH%=8
      GOSUB CALLINT
      MAXDRV% = DL%
      MAXHEAD% = DH%
      MAXCYL% = CH%+((CL% AND &HC0)*4)
      MAXSEC% = CL% AND &H3F
      RETURN
